#define MAX_WRITE_BUFFER        1024
#define MAX_READ_BUFFER         512
#define READ_TIMEOUT            10000

//#define AMOUNT_TO_READ          17
#define NUM_READSTAT_HANDLES    2

#define TWOPI					6.283185
#define PI						3.14159
#define D2R						0.0174533

#define PATHLEN					100


LRESULT CALLBACK WndProc( HWND hWnd, UINT messg,
								WPARAM wParam, LPARAM lParam );


BOOL	UpdateConnection(void);
HANDLE	SetupCommPort(void);
BOOL	ReadSetupFile(void);
void	InitGraphics(void);
void	op_file(void);
void	StartThreads(void);
DWORD	WINAPI ReaderProc(LPVOID threadId);
void	cal_stat();
void	GraphData(void);
void	PaintWindow(HWND hWnd);
void	InitStats(void);
void 	ClearStats(void);
BOOL 	InitTTYInfo(void);
void	ProcessMessage(unsigned char *c);
void	ChannelCheck(unsigned char *c, BYTE len);
int		GetDiskSpace(char *str, char *vol);
BOOL	BreakDownCommPort(void);
void	ReportError(char *szMessage);

HWND        ghwndMain;
short		wheight, amountToRead;
RECT		rc;
HBRUSH		brush;
RECT		rect1={0, 60, 19, 479};
RECT		rect2={465, 90, 600, 120};
//RECT		rect3={366, 19, 398, 51};

UINT		tMessage = WM_USER+2;

char szProgName[] = "winfluxWMP"; /* name of application */

DWORD	mainThreadId;
COMMTIMEOUTS gTimeoutsDefault = { 40, 0, 0, 0, 0 };

struct TTYInfoStruct
{
    HANDLE  hCommPort, hReader;
    DWORD   dwEventFlags;
//    CHAR    chFlag, chXON, chXOFF;
//    WORD    wXONLimit, wXOFFLimit;
//    DWORD   fRtsControl;
//    DWORD   fDtrControl;
    BOOL    fConnected, //fTransferring, fRepeating,
//            fLocalEcho, fNewLine,
//            fDisplayErrors, fAutowrap,
//            fCTSOutFlow, fDSROutFlow, fDSRInFlow, 
//            fXonXoffOutFlow, fXonXoffInFlow,
//            fTXafterXoffSent,
//            fNoReading, fNoWriting, fNoEvents, fNoStatus,
            fDisplayTimeouts;
    BYTE    bPort, bByteSize, bParity, bStopBits ;
    DWORD   dwBaudRate ;
    COMMTIMEOUTS timeoutsorig;
    COMMTIMEOUTS timeoutsnew;

} TTYInfo;

HANDLE ghThreadExitEvent;


//flux variables
#define SPEED  9600		/* set serial baud rate		           */
#define MAXCH  10		/* max number of channels to be scanned    */
	float dat[MAXCH][200];			/* array of scanned data   */
	
//	void *buffer1, *buffer2;                /* set buffers for windows */
//	void *buffer3, *buffer4;
//	unsigned size1, size2, size3, size4;    /* buffer size             */
//	int col[8] = {15,15,3,12,13,11,15,8};	/* set the colors          */
	int yold[MAXCH];                        /* old point in graphics   */
	int z[MAXCH];				/* plot z     in graphics  */
	int index = 0;				/* lag step index	   */
	int lag[MAXCH];				/* time lag index	   */
//	int raw[MAXCH];				/* integer out for raw file*/
	float r_mean[MAXCH];			/* running mean		   */
	float svar[MAXCH];         		/* scalar variances 	   */
	float wx[MAXCH],ux[MAXCH],vx[MAXCH];    /* scalar covariances      */
	float ww,uu,vv,uw,uv,wv;       		/* velocity var and covar. */
	float xp[MAXCH];                 	/* deviations from r_mean  */
	unsigned int sample = 1;       		/* samples per avg period  */
	FILE 	*fptr3;		/* file pointers for I/O   */
	HANDLE	fptr1=INVALID_HANDLE_VALUE; //reflux , fptr2=INVALID_HANDLE_VALUE;
	char fname[128],rfname[128],ufname[128];   /* file names		   */
	char efname[128];
	struct data
	{
	char name[10];		/*  variable name		*/
	short	nl;				//lenght of name field
	float cal;              /*  calibration coeff   	*/
	float slag;             /*  lag time in sec     	*/
	}
	var[MAXCH];             /*  data variance		*/
	int raw_op;             /*  raw data option     	*/
	int boom;               /*  boom direction      	*/
	int jday;               /*  Julian day          	*/
	int sample_rate;        /*  sonic output rate           */
	char diskr[PATHLEN]; 		/*  disk drive for raw files    */
	char diskd[PATHLEN];          /*  disk drive for dat files    */
	char	volr[6];
	char	vold[6];
	int nch = 8;     	/*  number of channels scanned  */
//	extern int rx_chars;    /*  number of characters in buf */
	float vari[MAXCH];      /*  another variance            */
	float x_bar[MAXCH];     /*  true mean's			  */
	int fcheck = 0;         /*  flag for file existance       */
	unsigned int kbyte;     /*  available space on 'raw' disk */
	float var_scale[MAXCH]; /*  variance for scaling graphs   */
	float kurt[MAXCH];      /*  kurtosis    		  */
	float skew[MAXCH];	/*  skewness			  */
	float wet,omwet;        /*  weights for running mean      */
	int port_num = 1;	/*  serial port number default    */
//	int print_op = 1;	/*  printer output option	  */